/**
 * 
 */
package electric_vehicles.Media;

/**
 * @author Ayla
 *
 */

import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import repast.simphony.essentials.RepastEssentials;
import repast.simphony.random.RandomHelper;

public class Media {
	
	static public List<MediaMessage>  d_history;
	
	public Media()
	{	
		d_history = new LinkedList<MediaMessage>();
	}
	
	/* Publish new messages which may be read by the agents
	*/
	public static void publishMessage(MediaMessage message)
	{
		d_history.add(message);
	}
	
	public static List<MediaMessage> getAdvertisements()
	{
		List<MediaMessage> ads = new LinkedList<MediaMessage>();
		
		int current_tick = (int)RepastEssentials.GetTickCount();
		
		// For each message ever published, decide whether it is viewed by the agent, with a max # of 10 messages
		// Probability of being viewed depends on publish date
		Collections.shuffle(d_history);
		for (MediaMessage message : d_history)
		{
			if (RandomHelper.nextDoubleFromTo(0, 1) <= Math.max(0.01, Math.pow(0.9, current_tick - message.publishTick)));
				ads.add(message);
				
			if (ads.size() == 5)
				break;
		}
		// If no message is selected, return empty list
		return ads;
	}
		
	public static boolean Empty()
	{
		return d_history.size() == 0 ? true : false;
	}
	
	public static MediaMessage getRecentMediaMessage()
	{
		if (d_history.size() >= 5)
			return d_history.get(d_history.size() - RandomHelper.nextIntFromTo(1, 5));
		return d_history.get(d_history.size() - 1);
	}

}
