/**
 * 
 */
package electric_vehicles.Media;

import repast.simphony.essentials.RepastEssentials;
import electric_vehicles.Enums.FuelType;
import electric_vehicles.Enums.MessageType;
import electric_vehicles.Memory.FuelTypeConcept;
import electric_vehicles.Memory.VehicleConcept;

/**
 * @author Ayla
 *
 */
public class MediaMessage {
	
	public MessageType messageType;
	
	public int publishTick;
	
	public FuelType fuelType;
	public String model;	
	
	public float range;
	public float price;
	public float kmCosts;	
	public float chargeTime;
	public float chargeTimeFast;
	public float failureCosts;
	public float emissions;
	
	// Create message about car model
	public MediaMessage(FuelType c_fuelType, String c_model, float c_price, float c_range, float c_emissions)
	{
		messageType = MessageType.MEDIA_MESSAGE_VEHICLE;
		publishTick = (int)RepastEssentials.GetTickCount();
		
		fuelType = c_fuelType;
		model = c_model;
		range = c_range;
		price = c_price;
		emissions = c_emissions;
	}
	
	// Create message about fuel type
	public MediaMessage(FuelType c_fuelType, float c_kmCosts, float c_failureCosts, float c_chargeTime, float c_chargeTimeFast)
	{
		messageType = MessageType.MEDIA_MESSAGE_FUEL;
		publishTick = (int)RepastEssentials.GetTickCount();
		
		fuelType = c_fuelType;		
		kmCosts = c_kmCosts;
		failureCosts = c_failureCosts;
		chargeTime = c_chargeTime;
		chargeTimeFast = c_chargeTimeFast;
	}
	
	public VehicleConcept asVehicleConcept()
	{
		return new VehicleConcept(fuelType, model, price, range, emissions);
	}
	
	public FuelTypeConcept asFuelTypeConcept()
	{
		return new FuelTypeConcept(fuelType, kmCosts, failureCosts, chargeTime, chargeTimeFast);
	}


}
