/**
 * 
 */
package electric_vehicles.Memory;

/**
 * @author Ayla
 *
 */
public class MemoryElement 
{
	private final int d_agent_id;
	private VehicleConcept d_owned_vehicle;					// Model name of other agent's own car
	public  float d_satisfaction;							// Existence satisfaction of other agent
	private float d_normative_weight;						// The similarity between the two agents
	
	// Constructor
	public MemoryElement(int agent_id)
	{
		d_owned_vehicle = null;
		d_agent_id = agent_id;
		d_satisfaction = 0;
		d_normative_weight = 0;		
	}
	
	// Getters
	public int getAgentID()							{ return d_agent_id; }	
	public VehicleConcept getOwnedVehicle()			{ return d_owned_vehicle; }	
	public float getSatisfaction()					{ return d_satisfaction; }
	public float getNormativeWeight()				{ return d_normative_weight; }
	
	/* After communicating with another agent, all relevant information is updated and stored
	 */
	public void updateInformation(VehicleConcept vehicle, float satisfaction, float normative)
	{
		d_owned_vehicle = vehicle;
		d_satisfaction = satisfaction;
		d_normative_weight = normative;	
	}
	
}