/**
 * 
 */
package electric_vehicles.Scenarios.Instructions;

import electric_vehicles.Vehicles.Battery;

/**
 * @author Ayla
 *
 */
public class BatteryCostsInstruction extends Instruction {
	
	int d_stop;
	float d_adjustment;
		
	public BatteryCostsInstruction(int start, int stop, int total_adjustment) 
	{
		super();
		d_stop = stop;
		d_adjustment = (float)total_adjustment / (stop - start);
	}

	public int activate()
	{		
		// Some adjustment must be made
		if (d_adjustment == 0)
			return 0;
		
		execute();
		return d_stop;
	}
	
	public void execute()
	{
		Battery.adjustKWhCosts(d_adjustment);
	}
	
}
