/**
 * 
 */
package electric_vehicles.Scenarios.Instructions;

import electric_vehicles.Vehicles.Battery;

/**
 * @author Ayla
 *
 */
public class BatteryLifeInstruction extends Instruction {

	int d_stop;
	
	float d_adjustment_fast;
	float d_adjustment_slow;
	
	public BatteryLifeInstruction(int start, int stop, int adjustment_fast, int adjustment_slow) 
	{
		super();
		d_stop = stop;
		d_adjustment_fast = (float)adjustment_fast / (stop - start);
		d_adjustment_slow = (float)adjustment_slow / (stop - start);
	}

	public int activate()
	{	
		// Some adjustment must be made
		if (d_adjustment_fast == 0 && d_adjustment_slow == 0)
			return 0;
		
		execute();
		return d_stop;
	}
	
	public void execute()
	{
		Battery.adjustBatteryLifeFast(d_adjustment_fast);
		Battery.adjustBatteryLifeSlow(d_adjustment_slow);
	}
	
}
