/**
 * 
 */
package electric_vehicles.Scenarios.Instructions;

import electric_vehicles.Enums.ChargeOption;
import electric_vehicles.VehicleInfrastructure.RechargeStation;

/**
 * @author Ayla
 *
 */
public class FuelCostsInstruction extends Instruction {

	private int d_stop;
	private ChargeOption d_type;	
	private float d_adjustment;
	
	public FuelCostsInstruction(int start, int stop, ChargeOption type, float costs) 
	{
		super();
		d_stop = stop;
		d_type = type;
		d_adjustment = costs / (stop - start);
	}
	
	public int activate()
	{		
		if (d_adjustment == 0)
			return 0;
	
		execute();		
		return d_stop;
	}
	
	public void execute()
	{
		RechargeStation.adjustKmCosts(d_type, d_adjustment);
	}

}
