/**
 * 
 */
package electric_vehicles.Scenarios.Instructions;

import electric_vehicles.Enums.ChargeOption;
import electric_vehicles.VehicleInfrastructure.RechargeStation;

/**
 * @author Ayla
 *
 */
public class FuelTimeInstruction extends Instruction {

	private int d_stop;
	private ChargeOption d_type;	
	private float d_adjustment;

	public FuelTimeInstruction(int start, int stop, ChargeOption type, int adjustment) 
	{
		super();
		d_stop = stop;
		d_type = type;
		d_adjustment = (float)adjustment / (stop - start); 
	}
	
	public int activate()
	{				
		if (d_adjustment == 0)
			return 0;
	
		execute();		
		return d_stop;
	}
	
	public void execute()
	{
		RechargeStation.adjustChargeTime(d_type, d_adjustment);
	}

}
