/**
 * 
 */
package electric_vehicles.Scenarios.Instructions;

import electric_vehicles.Enums.ChargeLocation;
import electric_vehicles.VehicleInfrastructure.RechargeStation;

/**
 * @author Ayla
 *
 */
public class InfrastructureInstruction extends Instruction {

	private int d_stop;
	private ChargeLocation d_charge_location;
	private float d_adjustment;
	
	public InfrastructureInstruction(int start, int stop, ChargeLocation charge_location, float adjustment) 
	{
		super();
		d_stop = stop;
		d_charge_location = charge_location;
		d_adjustment = adjustment / (stop - start);
	}
	
	public int activate()
	{	
		// Proportion of charge stations cannot decrease
		if (d_adjustment <= 0)
			return 0;
	
		execute();		
		return d_stop;
	}
	
	public void execute()
	{
		RechargeStation.adjustChargeProbability(d_charge_location, d_adjustment);
	}

}
