/**
 * 
 */
package electric_vehicles.Scenarios.Instructions;
import electric_vehicles.Enums.FuelType;
import electric_vehicles.VehicleInfrastructure.Mechanic;

/**
 * @author Ayla
 *
 */
public class MaintenanceCostsInstruction extends Instruction {

	private int d_stop;
	private FuelType d_type;
	private float d_adjustment;
	
	public MaintenanceCostsInstruction(int start, int stop, FuelType type, float adjustment) 
	{
		super();
		d_stop = stop;
		d_type = type;
		d_adjustment = adjustment / (stop - start);
	}
	
	public int activate()
	{			
		if (d_adjustment == 0 || d_type == FuelType.GASOLINE)
			return 0;
	
		execute();		
		return d_stop;
	}
	
	public void execute()
	{
		Mechanic.adjustFailRatio(d_type, d_adjustment);
	}

}
