/**
 * 
 */
package electric_vehicles.Scenarios.Instructions;

import repast.simphony.essentials.RepastEssentials;
import electric_vehicles.Enums.FuelType;
import electric_vehicles.VehicleInfrastructure.Marketplace;
import electric_vehicles.Vehicles.Battery;
import electric_vehicles.Vehicles.ElectricVehicle;
import electric_vehicles.Vehicles.GasolineVehicle;
import electric_vehicles.Vehicles.HybridVehicle;
import electric_vehicles.Vehicles.Vehicle;

/**
 * @author Ayla
 *
 */
public class VehicleInstruction extends Instruction {

	/**
	 * @param tick
	 * @param category
	 */
	public FuelType d_fuelType;
	public String d_model;
	public float d_price;
	public int d_emissions;
	public int d_range;
	public int d_capacity;
	
	public VehicleInstruction()
	{}
	
	public VehicleInstruction(FuelType ft, String model, float price, int emissions, int range, int capacity) {
		super();
		d_fuelType = ft;
		d_model = model;
		d_price = price;
		d_emissions = emissions;
		d_range = range;
		d_capacity = capacity;
	}
	
	public int activate()
	{
		Vehicle vehicle;
		switch (d_fuelType)
		{
		case ELECTRIC:	vehicle = new ElectricVehicle(d_fuelType, d_model, (int)RepastEssentials.GetTickCount(), d_price, d_capacity * Battery.getKWhCosts(), d_emissions, d_capacity);
						break;
		case GASOLINE:	vehicle = new GasolineVehicle(d_fuelType, d_model, (int)RepastEssentials.GetTickCount(), d_price, d_range, d_emissions);
						break;
		case HYBRID:	vehicle = new HybridVehicle(d_fuelType, d_model, (int)RepastEssentials.GetTickCount(), d_price, d_capacity * Battery.getKWhCosts(), d_range, d_emissions, d_capacity);
						break;
		default:		System.out.println("ERROR while introducing a " + d_fuelType + " car called " + d_model); 
						return 0;
		}
		Marketplace.introduceCar(vehicle);
		
		// Vehicle introduction is always done instantly
		return 0;
	}

}
