/**
 * 
 */
package electric_vehicles.Vehicles;

import repast.simphony.engine.environment.RunEnvironment;
/*import repast.simphony.engine.schedule.ScheduledMethod;
*/import repast.simphony.parameter.Parameters;

/**
 * @author Ayla
 *
 */
public class Battery {
	
	static private float kwh_costs;						// Costs of new battery in euro per 1 kWh
	static private float fuel_economy_factor;			// kWh needed to drive 1 km
	static private float charge_capacity_fast;			// Max capacity load when fast charging
	static private float max_range_decrease;			// Capacity decrease until battery is flagged as broken 
	static private float battery_life_slow;			// Average battery life when only using slow charge
	static private float battery_life_fast;			// Average battery life when only using fast charge
	
	
	public Battery()
	{
		Parameters params = RunEnvironment.getInstance().getParameters();
		
		kwh_costs = ( Integer )params.getValue("kwh_costs");
		fuel_economy_factor = ( Float )params.getValue("battery_fuel_economy");
		charge_capacity_fast = ( Float )params.getValue("charge_capacity_fast");
		max_range_decrease = ( Float )params.getValue("max_range_decrease");
		battery_life_slow = ( Float )params.getValue("battery_life_slow");
		battery_life_fast = ( Float )params.getValue("battery_life_fast");
	}
	
	public static float getKWhCosts()						{ return kwh_costs; }	
	public static float getFuelEconomyFactor()				{ return fuel_economy_factor; }	
	public static float getChargeCapacityFast()				{ return charge_capacity_fast; }	
	public static float getMaxRangeDecrease()				{ return max_range_decrease; }	
	public static float getBatteryLifeSlow()				{ return battery_life_slow; }
	public static float getBatteryLifeFast()				{ return battery_life_fast; }
	
	public static void adjustBatteryLifeFast(float adjustment)	{ battery_life_fast += adjustment; }
	public static void adjustBatteryLifeSlow(float adjustment)	{ battery_life_slow += adjustment; }
	public static void adjustKWhCosts(float adjustment)			{ kwh_costs += adjustment; }

}
