
package electric_vehicles.Vehicles;


/*
 *  Struct that carries information of the drive an agent took in its car
 */
public class DriveLog 
{
	public int d_distance;					// Total distance driven this drive
	public int d_remainingKm;				// Used for bookkeeping when driving
	public float d_refillCosts;				// Total costs of all the recharges/refills
	public int d_refillEnergy;
	public int d_minutesLate;				// Possible lateness, due to recharging of the EV
	public int d_failureCosts;				// List of the costs of all encountered failures
	public boolean d_batteryBroken;
	public int d_electricKmWithPHEV;
	
	public DriveLog(int total_distance) 
	{
		d_distance = total_distance;
		d_remainingKm = total_distance;
		d_refillCosts = 0;
		d_refillEnergy = 0;
		d_minutesLate = 0;
		d_failureCosts = 0;
		d_batteryBroken = false;
		d_electricKmWithPHEV = 0;
	}

}
